## sword 1.9.0%2Bdfsg

=== bindings/csharp/Makefile ===
all: Sword.exe

Sword.exe:
	xbuild Sword.csproj /p:Configuration=Release

clean:
	xbuild Sword.csproj /p:Configuration=Release /t:Clean

=== tests/testsuite/CMakeLists.txt ===
#############################################################################
# This file will actually be responsible for running the tests
#

FILE(WRITE "${CMAKE_CURRENT_BINARY_DIR}/sword.conf" "[Install]\nLocalePath=${CMAKE_CURRENT_SOURCE_DIR}/../../")

FILE(WRITE "${CMAKE_CURRENT_BINARY_DIR}/sword.conf"
	"[Install]\nLocalePath=${CMAKE_CURRENT_SOURCE_DIR}/../../")

ADD_CUSTOM_TARGET(
	tests_configure
	COMMAND cp "${CMAKE_CURRENT_SOURCE_DIR}/*.{sh,good,imp,txt,xml}" "${CMAKE_CURRENT_BINARY_DIR}"
	DEPENDS ${test_PROGRAMS}
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

FILE(GLOB TEST_SUITE RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "*.good")
FOREACH(TEST ${TEST_SUITE})
	GET_FILENAME_COMPONENT(TEST_NAME "${TEST}" NAME_WE)
	ADD_TEST(NAME "${TEST_NAME}"
		WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
		COMMAND ./runtest.sh "${TEST_NAME}")
	MESSAGE(STATUS "  Adding test ${TEST_NAME}")
ENDFOREACH(TEST ${TEST_SUITE})

ADD_DEPENDENCIES(
	buildtest
	tests_configure
)

MESSAGE(STATUS "Testing configured.")

=== bindings/corba/omniorbcpp/Makefile ===
all: server testclient

PREFIX = $(shell grep ^prefix ../../../Makefile|cut -f3 -d' ')

#sword stuff
CXXFLAGS += $(shell PKG_CONFIG_PATH=${PREFIX}/lib/pkgconfig pkg-config --cflags sword)
CFLAGS += $(shell PKG_CONFIG_PATH=${PREFIX}/lib/pkgconfig pkg-config --cflags sword)
LIBS += $(shell PKG_CONFIG_PATH=${PREFIX}/lib/pkgconfig pkg-config --libs sword)

#omniORB stuff
CFLAGS += $(shell PKG_CONFIG_PATH=${PREFIX}/lib/pkgconfig pkg-config --cflags omniORB4)
CXXFLAGS += $(shell PKG_CONFIG_PATH=${PREFIX}/lib/pkgconfig pkg-config --cflags omniORB4)
LIBS += $(shell PKG_CONFIG_PATH=${PREFIX}/lib/pkgconfig pkg-config --libs omniORB4)

LIBS += -L/usr/lib64 

#comment out for release
#CXXFLAGS += -g -O0
#CFLAGS += -g -O0
#LDFLAGS += -g -O0
CXXFLAGS += -O3 -std=c++0x
CFLAGS += -O3
#-----------------------------------------------------------------------------


server: server.cpp swordorb-impl.o swordorb-stubs.o 
	$(CXX) $(CXXFLAGS) -I. -o server server.cpp swordorb-impl.o swordorb-stubs.o $(LIBS)

testclient: testclient.cpp swordorb-impl.cpp swordorb-stubs.o 
	$(CXX) $(CXXFLAGS) -I. -o testclient testclient.cpp swordorb-stubs.o $(LIBS)

swordorb-impl.o: swordorb.h swordorb-impl.cpp 
	$(CXX) $(CXXFLAGS) -I. -c swordorb-impl.cpp


swordorb.h: ./../swordorb.idl
	omniidl -bcxx -Wbh=.h -Wbs=-stubs.cpp ./../swordorb.idl

swordorb-stubs.o: swordorb-stubs.cpp
	$(CC) $(CFLAGS) -I. -c swordorb-stubs.cpp

clean:
	rm -f *.h *-stubs.cpp *.cc *.o *.c server testclient

install:
	mkdir -p $(PREFIX)/bin
	cp -f server $(PREFIX)/bin/swordorbserver

=== debian/control ===
Source: sword
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               dh-python,
               libbz2-dev,
               liblzma-dev,
               libz-dev,
               pkg-config,
               libcurl4-gnutls-dev,
               libclucene-dev,
               libicu-dev,
               chrpath,
               swig,
               python3-dev,
               python3-setuptools,
               cmake
Section: libs
Priority: optional
Maintainer: CrossWire Packaging Team <pkg-crosswire-devel@alioth-lists.debian.net>
Uploaders: Daniel Glassey <wdg@debian.org>,
 Jonathan Marsden <jmarsden@fastmail.fm>,
 Dominique Corbex <dominique@corbex.org>,
 Teus Benschop <teusjannette@gmail.com>
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://www.crosswire.org/sword/
Vcs-Browser: https://salsa.debian.org/pkg-crosswire-team/sword
Vcs-Git: https://salsa.debian.org/pkg-crosswire-team/sword.git

Package: libsword1.9.0t64
Provides: ${t64:Provides}
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libsword-common, ${shlibs:Depends}, ${misc:Depends}
Recommends: sword-frontend
Breaks: libsword1.9.0 (<< ${source:Version}), libsword11v5 (>= 1.8), libsword-1.8.1
Replaces: libsword1.9.0, libsword11v5 (>= 1.8), libsword-1.8.1
Multi-Arch: same
Description: API/library for bible software
 The SWORD Project is an open source, cross-platform (Linux, Windows, Solaris,
 MacOSX etc.) API/library for Bible software with a constantly growing list
 of front-ends (GUI, textmode, web-based, etc.) and a library of over 200
 text modules.
 .
 This package contains the core libraries for the project.
 It also contains utilities for generating data modules.
 .
 Please read the README.Debian for more information on how to obtain other
 modules for SWORD.

Package: libsword-dev
Architecture: any
Section: libdevel
Depends: libsword1.9.0t64 (= ${binary:Version}), ${misc:Depends}
Recommends: libsword-utils
Multi-Arch: same
Description: Development files for libsword
 The SWORD Project is an open source, cross-platform (Linux, Windows, Solaris,
 MacOSX etc.) API/library for Bible software with a constantly growing list
 of front-ends (GUI, textmode, web-based, etc.) and a library of over 200
 text modules.
 .
 This package contains the static libraries and headers for developing
 applications that use the SWORD library.

Package: libsword-common
Architecture: all
Section: devel
Depends: ${misc:Depends}
Conflicts: libsword6, libsword7, libsword8
Replaces: libsword6, libsword7, libsword8
Multi-Arch: foreign
Description: common settings and module repository for libsword
 The SWORD Project is an open source, cross-platform (Linux, Windows, Solaris,
 MacOSX etc.) API/library for Bible software with a constantly growing list
 of front-ends (GUI, textmode, web-based, etc.) and a library of over 200
 text modules.
 .
 This package contains sword configuration and global module repository.

Package: libsword-utils
Architecture: any
Section: devel
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libsword6, libsword7, libsword8
Replaces: libsword6, libsword7, libsword8
Description: conversion utilities for bible documents in SWORD supported formats
 The SWORD Project is an open source, cross-platform (Linux, Windows, Solaris,
 MacOSX etc.) API/library for Bible software with a constantly growing list
 of front-ends (GUI, textmode, web-based, etc.) and a library of over 200
 text modules.
 .
 This package contains utilities to convert documents in various
 formats into those suitable to be used with SWORD library.

Package: python3-sword
Architecture: any
Section: python
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: Python 3 bindings for the SWORD bible library
 The SWORD Project is an open source, cross-platform (Linux, Windows, Solaris,
 MacOSX etc.) API/library for Bible software with a constantly growing list
 of front-ends (GUI, textmode, web-based, etc.) and a library of over 200
 text modules.
 .
 This package contains the Python 3 bindings for SWORD.

Package: diatheke
Architecture: any
Section: text
Provides: sword-frontend
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: command line bible browsing and search tool
 The SWORD Project is an open source, cross-platform (Linux, Windows, Solaris,
 MacOSX etc.) API/library for Bible software with a constantly growing list
 of front-ends (GUI, textmode, web-based, etc.) and a library of over 200
 text modules.
 .
 This package contains a command line utility for SWORD, allowing
 bible browsing and searching. This tool is used mostly only for
 library testing. Nicer front-ends are Xiphos (Gtk), Bibletime (Qt)
 and others.

## sword 1.9.0+dfsg

=== CMakeLists.txt ===
# TODO: limit pkg-config version to >= 0.14, demo, utilities, doc, tests
#       use BUILD_SHARED_LIBS
#       convince perl swig bindings to build properly
#
# NOTES: Defaults to build type of Shared
#        Forces out-of-source tree build
#
#
# This file started on 18 January 2010 by Gregory Hellings
# It is ceded to The SWORD Library developers and CrossWire under the terms
# of their own GPLv2 license and all copyright is transferred to them for
# all posterity and eternity, wherever such transfer is possible.  Where it is
# not, then this file is released under the GPLv2 by myself.
PROJECT(libsword CXX C)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0)
SET(SWORD_VERSION 1.9.0)

# Make sure it's an out-of-stream build
IF(${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
	MESSAGE(FATAL_ERROR "Please invoke CMake from a different directory than the source.")
ENDIF(${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})

MESSAGE(STATUS "Configuring your system to build libsword.")

###########################################################################################
# Here are some basic CMake variables we need to setup in order for things to work properly
#
# Our include directory, for our own internally created "FIND_PACKAGE" calls, like CLucene
SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
# User options
INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/cmake/options.cmake")
# Source variables
INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/cmake/sources.cmake")
# Cppcheck
INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/cmake/CppcheckTargets.cmake")
# Our local includes
INCLUDE_DIRECTORIES("${CMAKE_CURRENT_BINARY_DIR}/include") # For swversion.h
INCLUDE_DIRECTORIES("${CMAKE_CURRENT_SOURCE_DIR}/include") # For everything else
IF(MSVC)
	INCLUDE_DIRECTORIES("${CMAKE_CURRENT_SOURCE_DIR}/src/utilfuns/win32/")
	ADD_DEFINITIONS(-DWIN32 -D_ICUSWORD_ -D_LIB -DREGEX_MALLOC -DSWMAKINGDLL -D_CRT_SECURE_NO_WARNINGS -DCURL_STATICLIB -DUSBINARY -D_CRT_SECURE_NO_DEPRECATE)
ENDIF(MSVC)

###########################################################################################
# This will look for various libraries that libsword builds against.  There is no REQUIRED
# attribute added here, since all of the libraries here are not, in actuality, required.
#
MESSAGE(STATUS "\n-- SEARCHING FOR SYTEM PACKAGES")
# Find our packages
FIND_PACKAGE(BZIP2 QUIET)
FIND_PACKAGE(XZ QUIET)
FIND_PACKAGE(ICU QUIET
                COMPONENTS data i18n io uc)
FIND_PACKAGE(CURL QUIET)
FIND_PACKAGE(CLucene QUIET)
FIND_PACKAGE(ZLIB QUIET)
FIND_PACKAGE(PkgConfig QUIET)
FIND_PACKAGE(Regex QUIET)

###########################################################################################
# Based on user input and the results of the above tests, we may need to mux with the source
# files to use an internal version of ZLib, cURL-like stuff, or CLucene replacements.  These
# lines below will modify the source files directories so that the required files are only
# included if the option is needed.
#
# Modify the source variables and set necessary definitions, this is a rather long segment,
# so I have sorted it out into its own file
INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/muxsources.cmake)

################################################################################################
# This actually creates the build target that is the libsword building target to be generated.
# Most of the work for configuration is done above, already.
#
# I want to do this manually, there might be reason in the future
SET(CPPCHECK_POSSIBLEERROR_ARG "--enable=all")
IF(LIBSWORD_LIBRARY_TYPE MATCHES ".*Shared.*" OR NOT LIBSWORD_LIBRARY_TYPE)
	ADD_LIBRARY(sword SHARED ${sword_SOURCES})
    ADD_CPPCHECK(sword
        POSSIBLE_ERROR TRUE
        FORCE TRUE)
	MESSAGE(STATUS "Building Shared library.")
	SET(BUILDING_SHARED 1)
	SET(SWORD_LINK_NAME sword)
ENDIF(LIBSWORD_LIBRARY_TYPE MATCHES ".*Shared.*" OR NOT LIBSWORD_LIBRARY_TYPE)

IF(LIBSWORD_LIBRARY_TYPE MATCHES ".*Static.*" OR NOT LIBSWORD_LIBRARY_TYPE)
	ADD_LIBRARY(sword_static STATIC ${sword_SOURCES})
    ADD_CPPCHECK(sword_static
        POSSIBLE_ERROR TRUE
        FORCE TRUE)
	SET_TARGET_PROPERTIES(sword_static PROPERTIES COMPILE_FLAGS "-fPIC")
	SET(BUILDING_STATIC 1)
	# Defaults to linking against the shared if it is also being built
	IF(NOT BUILDING_SHARED)
		SET(SWORD_LINK_NAME sword_static)
	ENDIF(NOT BUILDING_SHARED)
	# With MSVC, the .dll files also create .lib files of the same name
	# with the exported symbols.  Thus, we don't want the two to have the
	# same exact name.  In other systems, the .a and .so suffixes suffice
	# to keep them separate
	IF(NOT MSVC OR NOT LIBSWORD_LIBRARY_TYPE MATCHES ".*Shared.*")
		SET_TARGET_PROPERTIES(sword_static PROPERTIES
			OUTPUT_NAME "sword")
		#MESSAGE(STATUS "Building Static library with name sword")
	ELSE(NOT MSVC OR NOT LIBSWORD_LIBRARY_TYPE MATCHES ".*Shared.*")
		#MESSAGE(STATUS "Building Static library with name
		#sword_static")
	ENDIF(NOT MSVC OR NOT LIBSWORD_LIBRARY_TYPE MATCHES ".*Shared.*")
	MESSAGE(STATUS "Building Static library.")
ENDIF(LIBSWORD_LIBRARY_TYPE MATCHES ".*Static.*" OR NOT LIBSWORD_LIBRARY_TYPE)

################################################################################################
# Some random user settings
#
ADD_DEFINITIONS(-DGLOBCONFPATH="${SYSCONF_INSTALL_DIR}/sword.conf")
SET(CONFFILE "[Install]
DataPath=${SHARE_INSTALL_PREFIX}/sword")
FILE(WRITE "${CMAKE_CURRENT_BINARY_DIR}/sword.conf" "${CONFFILE}")


###############################################################################################
# This allows the user to set a SONAME for the library.  This allows packagers and those who
# care about that sort of thing to be happy and have all their SONAMES set properly.
#
IF(NOT LIBSWORD_SOVERSION AND BUILDING_SHARED)
        SET(SWORD_SOVERSION ${SWORD_VERSION})
ELSE(NOT LIBSWORD_SOVERSION AND BUILDING_SHARED)
        SET(SWORD_SOVERSION ${LIBSWORD_SOVERSION})
ENDIF(NOT LIBSWORD_SOVERSION AND BUILDING_SHARED)

IF(BUILDING_SHARED)
	SET_TARGET_PROPERTIES(sword
		PROPERTIES SOVERSION ${SWORD_SOVERSION})
	MESSAGE(STATUS "Setting SOVERSION to ${SWORD_SOVERSION}")
ENDIF(BUILDING_SHARED)

###############################################################################################
# The buildflags depend on the CMAKE_BUILD_TYPE supplied at the command line.
# For a full lists of different flags see http://cmake.org/Wiki/CMake_Useful_Variables
#
# Cmake has sane defaults for None aka '', DEBUG, RELEASE, RELWITHDEBINFO for known compilers.
#
# You can override these variables on the command-line or here.
# We provide our own defaults below
#
# Note the below two initialisations done for us by cmake:
#
#SET(CMAKE_C_FLAGS                  "${CMAKE_C_FLAGS}"   or "$ENV{CFLAGS}" or "" )
#SET(CMAKE_CXX_FLAGS                "${CMAKE_CXX_FLAGS}" or "$ENV{CXXFLAGS}" or "" )

IF(SWORD_ENABLE_WARNINGS STREQUAL "Yes")
	SET(CMAKE_C_FLAGS "-Werror ${CMAKE_C_FLAGS}")
	SET(CMAKE_CXX_FLAGS "-Werror ${CMAKE_CXX_FLAGS}")
ENDIF(SWORD_ENABLE_WARNINGS STREQUAL "Yes")

IF(SWORD_ENABLE_PROFILE STREQUAL "Yes")
	SET(CMAKE_C_FLAGS   "-pg ${CMAKE_C_FLAGS}")
	SET(CMAKE_CXX_FLAGS "-pg ${CMAKE_CXX_FLAGS}")
ENDIF(SWORD_ENABLE_PROFILE STREQUAL "Yes")

IF(SWORD_ENABLE_PROFILEFN STREQUAL "Yes")
	SET(CMAKE_C_FLAGS   "-g -finstrument-functions ${CMAKE_C_FLAGS}")
	SET(CMAKE_CXX_FLAGS "-g -finstrument-functions ${CMAKE_CXX_FLAGS}")
	TARGET_LINK_LIBRARIES(libsword fnccheck)
ENDIF(SWORD_ENABLE_PROFILEFN STREQUAL "Yes")

IF(MSVC)
	SET(CMAKE_C_FLAGS_DEBUG            "/D /O0 /DDEBUG ${CMAKE_C_FLAGS}")
	SET(CMAKE_C_FLAGS_RELEASE          "/O3 /DNDEBUG ${CMAKE_C_FLAGS}")
	SET(CMAKE_C_FLAGS_RELWITHDEBINFO   "/O3 /D /DDEBUG ${CMAKE_C_FLAGS}")
	SET(CMAKE_CXX_FLAGS_DEBUG          "/D /O0 /DDEBUG ${CMAKE_CXX_FLAGS}")
	SET(CMAKE_CXX_FLAGS_RELEASE        "/O3 ${CMAKE_CXX_FLAGS}")
	SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "/O3 /D /DDEBUG ${CMAKE_CXX_FLAGS}")
ELSE(MSVC)
	SET(CMAKE_C_FLAGS_DEBUG            "-g3 -Wall -O0 ${CMAKE_C_FLAGS}")
	SET(CMAKE_C_FLAGS_RELEASE          "-O3 ${CMAKE_C_FLAGS}")
	SET(CMAKE_C_FLAGS_RELWITHDEBINFO   "-O3 -g ${CMAKE_C_FLAGS}")
	SET(CMAKE_CXX_FLAGS_DEBUG          "-g3 -Wall -O0 ${CMAKE_CXX_FLAGS}")
	SET(CMAKE_CXX_FLAGS_RELEASE        "-O3 ${CMAKE_CXX_FLAGS}")
	SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O3 -g ${CMAKE_CXX_FLAGS}")
ENDIF(MSVC)
##############################################################################################
# Setting libraries and includes
#

IF(WITH_ZLIB)
	INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
	SET(SWORD_LINK_LIBRARIES ${SWORD_LINK_LIBRARIES} ${ZLIB_LIBRARY})
ENDIF(WITH_ZLIB)
IF(WITH_BZIP2)
	INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})
	SET(SWORD_LINK_LIBRARIES ${SWORD_LINK_LIBRARIES} ${BZIP2_LIBRARY})
ENDIF(WITH_BZIP2)
IF(WITH_XZ)
	INCLUDE_DIRECTORIES(${XZ_INCLUDE_DIR})
	SET(SWORD_LINK_LIBRARIES ${SWORD_LINK_LIBRARIES} ${XZ_LIBRARY})
ENDIF(WITH_XZ)
IF(WITH_CURL)
	FIND_PROGRAM(CURL_CONFIG curl-config
		DOC "The curl-config executable path, used to determine SFTP support.")
	# If we can find the config script, we will run it and attempt to parse out the
	# availability of SFTP support. Otherwise, we will assume the library was built
	# without it.
	IF(CURL_CONFIG)
		EXECUTE_PROCESS(
			COMMAND ${CURL_CONFIG} --protocols
			COMMAND grep SFTP
			COMMAND wc -l
			OUTPUT_VARIABLE CURL_CONFIG_OUTPUT
			OUTPUT_STRIP_TRAILING_WHITESPACE)
		IF(CURL_CONFIG_OUTPUT STREQUAL "1")
			ADD_DEFINITIONS(-DCURLSFTPAVAILABLE)
			MESSAGE(STATUS "cURL SFTP Support: Yes")
		ELSE(CURL_CONFIG_OUTPUT STREQUAL "1")
			MESSAGE(STATUS "cURL SFTP Support: No")
		ENDIF(CURL_CONFIG_OUTPUT STREQUAL "1")
	ENDIF(CURL_CONFIG)
	INCLUDE_DIRECTORIES(${CURL_INCLUDE_DIRS})
	SET(SWORD_LINK_LIBRARIES ${SWORD_LINK_LIBRARIES} ${CURL_LIBRARY})
ENDIF(WITH_CURL)
IF(WITH_CLUCENE)
	INCLUDE_DIRECTORIES(${CLUCENE_INCLUDE_DIR})
	SET(SWORD_LINK_LIBRARIES ${SWORD_LINK_LIBRARIES} ${CLUCENE_LIBRARY})
	LINK_DIRECTORIES(${CLUCENE_LIBRARY_DIR})
	ADD_DEFINITIONS(-DUSELUCENE)
	IF(CLUCENE2)
		ADD_DEFINITIONS(-DCLUCENE2)
	ENDIF(CLUCENE2)
ENDIF(WITH_CLUCENE)
IF(WITH_ICU)
	INCLUDE_DIRECTORIES(${ICU_INCLUDE_DIRS})
	ADD_DEFINITIONS(${ICU_DEFINITIONS})
	MESSAGE(STATUS "ICU Version: ${ICU_VERSION}")
	IF("${ICU_VERSION}" VERSION_GREATER "61")
		ADD_DEFINITIONS(-DU_USING_ICU_NAMESPACE)
	ENDIF("${ICU_VERSION}" VERSION_GREATER "61")
	SET(SWORD_LINK_LIBRARIES ${SWORD_LINK_LIBRARIES} ${ICU_LIBRARY})
ENDIF(WITH_ICU)
IF(REGEX_FOUND AND CROSS_COMPILE_MINGW32)
	SET(SWORD_LINK_LIBRARIES ${SWORD_LINK_LIBRARIES} ${REGEX_LIBRARY})
ENDIF(REGEX_FOUND AND CROSS_COMPILE_MINGW32)

IF(BUILDING_SHARED)
	TARGET_LINK_LIBRARIES(sword ${SWORD_LINK_LIBRARIES})
ENDIF(BUILDING_SHARED)

IF(BUILDING_STATIC)
	TARGET_LINK_LIBRARIES(sword_static ${SWORD_LINK_LIBRARIES})
ENDIF(BUILDING_STATIC)

MESSAGE(STATUS "Setting link libraries to ${SWORD_LINK_LIBRARIES}")

##############################################################################################
#########
### TODO: Not sure about these...
#########
##############################################################################################
ADD_DEFINITIONS(-D_FTPLIB_NO_COMPAT)

#############################################################################################
# Platform-specifc bits that I will eventually refactor out into their own files, once I am happy
# with the stuff that is here.
#
IF(APPLE OR iPhone)
	ADD_DEFINITIONS(-Dunix)
ENDIF(APPLE OR iPhone)

##############################################################################################
# Our build test
#

ADD_EXECUTABLE(buildtest buildtest.cpp)
IF(BUILDING_STATIC)
	TARGET_LINK_LIBRARIES(buildtest sword_static)
ELSE(BUILDING_STATIC)
	TARGET_LINK_LIBRARIES(buildtest sword)
ENDIF(BUILDING_STATIC)

##############################################################################################
# Installing the library, headers, utilies, etc
#

INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/cmake/install.cmake")

=== doc/Makefile ===
all: doxygen

doxygen: Doxyfile
	cd .. && doxygen doc/Doxyfile

clean:
	rm -rf doxygen

deploy:doxygen
	rm -rf /home/sword/html/apiref
	cp -a doxygen/html /home/sword/html/apiref

=== tests/CMakeLists.txt ===
#########################################################################################
# A test suite - that is awesome.

MESSAGE(STATUS "\n-- CONFIGURING LIBRARY TESTS")

SET(test_PROGRAMS
	bibliotest
	casttest
	ciphertest
	complzss
	compnone
	configtest
	filtertest
	httptest
	introtest
	indextest
	keycast
	keytest
	lextest
	listtest
	localetest
	mgrtest
	modtest
	osistest
	ldtest
	parsekey
	rawldidxtest
	romantest
	striptest
	swaptest
	swbuftest
	testblocks
	utf8norm
	versekeytest
	vtreekeytest
	versemgrtest
	webiftest
	xmltest
)

IF(WITH_ICU)
	SET(test_PROGRAMS
		${test_PROGRAMS}
		icutest
		tlitmgrtest
		translittest
	)
ENDIF(WITH_ICU)

IF(WITH_ZLIB OR WITH_INTERNAL_ZLIB)
	SET(test_PROGRAMS
		${test_PROGRAMS}
		compzip
	)
ENDIF(WITH_ZLIB OR WITH_INTERNAL_ZLIB)

FOREACH(TEST ${test_PROGRAMS})
	ADD_EXECUTABLE(${TEST} ${TEST}.cpp)
	IF(BUILDING_SHARED)
		TARGET_LINK_LIBRARIES(${TEST}	sword)
	ELSE(BUILDING_SHARED)
		TARGET_LINK_LIBRARIES(${TEST} sword_static)
	ENDIF(BUILDING_SHARED)
ENDFOREACH(TEST ${test_PROGRAMS})

########################################################################################
# The following tests require extra libraries to run
#
IF(WITH_ICU)
	FOREACH(ICUTEST icutest translittest tlitmgrtest)
        TARGET_LINK_LIBRARIES(${ICUTEST} ${ICU_LIBRARY})
	ENDFOREACH(ICUTEST icutest translittest)
ENDIF(WITH_ICU)

# Excluded until I know we have the tests working
ADD_SUBDIRECTORY(testsuite)

=== bindings/gsoap/Makefile ===
all: gsoapsword testclient

gsoapsword:	gsoapsword.h gsoapsword.cpp stdsoap.o
	./soapcpp gsoapsword.h
	g++ -g -ggdb -I/usr/include/sword -I./include -o gsoapsword gsoapsword.cpp yoyo.cpp stdsoap.o soapC.cpp soapServer.cpp -lsword -lz

testclient:	gsoapsword.h testclient.cpp stdsoap.o
	./soapcpp gsoapsword.h
	g++ -I./include -o testclient testclient.cpp stdsoap.o soapC.cpp soapClient.cpp

clean:
	rm gsoapsword testclient soapC.cpp soapServer.cpp soapClient.cpp soapH.h soapStub.h sword.xsd sword.nsmap sword.wsdl

=== bindings/java-jni/Makefile ===
all:
	cp ../corba/orbitcpp/webmgr.hpp jni/
	mkdir -p classes
	javac -d classes src/org/crosswire/android/sword/*.java
	javah -d jni -classpath classes -jni org.crosswire.android.sword.SWMgr
	javah -d jni -classpath classes -jni org.crosswire.android.sword.SWModule
	javah -d jni -classpath classes -jni org.crosswire.android.sword.InstallMgr
	javap -s -classpath classes/ org.crosswire.android.sword.SWMgr > SWMgr.txt
	javap -s -classpath classes/ org.crosswire.android.sword.SWMgr.ModInfo > ModInfo.txt
	javap -s -classpath classes/ org.crosswire.android.sword.SWModule > SWModule.txt
	javap -s -classpath classes/ org.crosswire.android.sword.SWModule.SearchHit > SearchHit.txt
	javap -s -classpath classes/ org.crosswire.android.sword.SWModule.SearchProgressReporter > SearchProgressReporter.txt
	javap -s -classpath classes/ org.crosswire.android.sword.InstallMgr > InstallMgr.txt
	# cp these things over to our Android JNI Project
	cp src/org/crosswire/android/sword/*.java ../Android/SWORD/app/src/main/java/org/crosswire/android/sword/
	ln -sf ../../../../../../../src/keys ../Android/SWORD/app/src/main/cpp/
	ln -sf ../../../../../../../src/utilfuns ../Android/SWORD/app/src/main/cpp/
	ln -sf ../../../../../../../src/mgr ../Android/SWORD/app/src/main/cpp/
	ln -sf ../../../../../../../src/modules ../Android/SWORD/app/src/main/cpp/
	ln -sf ../../../../../../../src/frontend ../Android/SWORD/app/src/main/cpp/
	ln -sf ../../../../../../java-jni/jni ../Android/SWORD/app/src/main/cpp/
	ln -sf ../../../../../../../../biblesync/src/ ../Android/SWORD/app/src/main/cpp/biblesync


clean:
	rm -rf classes jni/org_crosswire_android_sword_*.h *.txt

=== bindings/objc/Makefile ===
#
# First enter dependencies/ and run make
#
# For Universal libSWORD.a use XCode and compile SWORD/SWORD.xcodeproj
# then if you'd like to add ios support to the ../cordova bindings,
# this Makefile in here will copy the Universal lib and other deps
# to the correct locations
#
# just type: make
#

all: deploycordova

deploycordova:
	mkdir -p ../cordova/cordova-plugin-crosswire-sword/libs/ios/
	cp ./dependencies/curl/lib/libcurl.a ../cordova/cordova-plugin-crosswire-sword/libs/ios/
#	cp ./Build/Debug-iphonesimulator/libSWORD.a ../cordova/cordova-plugin-crosswire-sword/libs/ios/
#	cp ./Build/Debug-iphoneos/libSWORD.a ../cordova/cordova-plugin-crosswire-sword/libs/ios/
	cp SWORD/Release-universal/libSWORD.a ../cordova/cordova-plugin-crosswire-sword/libs/ios/
	cp ../../include/defs.h ../../include/flatapi.h ../cordova/cordova-plugin-crosswire-sword/src/ios/

=== bindings/swig/CMakeLists.txt ===
#####################################################################################################
#
# A system to, hopefully, build the Sword bindings which are asked for.  Currently I only know and
# therefore only support Python & Perl bindings.  YMMV for it, please submit patches or suggestions.
# I will try to get them integrated into the system if I can.  If there are bindings that you need
# other than the Python|Perl/Swig bindings, then you should probably speak up now.

MESSAGE(STATUS "\n-- CONFIGURING SWIG BINDINGS")
#####################################################################################################
# SWIG
# We need to find the SWIG executable in order to be able to do this, right?
FIND_PACKAGE(SWIG)

IF(NOT SWIG_FOUND)
	MESSAGE(FATAL_ERROR "Swig: no")
ELSE(NOT SWIG_FOUND)
	MESSAGE(STATUS "Swig: yes")

	SET(CMAKE_SWIG_FLAGS "-w-451,-402;-shadow;-c++")

	MACRO(SWORD_SWIG_GENERATE LANG)
		ADD_CUSTOM_COMMAND(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/Sword.cxx"
			COMMAND ${SWIG_EXECUTABLE} ${CMAKE_SWIG_FLAGS} -${LANG} -o "${CMAKE_CURRENT_BINARY_DIR}/Sword.cxx"
				"-I${CMAKE_SOURCE_DIR}/bindings/swig" ${SWIG_INCLUDES} "${CMAKE_SOURCE_DIR}/bindings/swig/sword.i"
			WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
	ENDMACRO(SWORD_SWIG_GENERATE)

	GET_DIRECTORY_PROPERTY(cmake_include_directories INCLUDE_DIRECTORIES)
	SET(SWIG_INCLUDES)
	FOREACH(directory ${cmake_include_directories})
		SET(SWIG_INCLUDES ${SWIG_INCLUDES} "-I${directory}")
	ENDFOREACH(directory ${cmake_include_directories})

	IF(SWORD_PYTHON_2)
		SET(SWORD_PYTHON_VERSION 2)
		ADD_SUBDIRECTORY(python python2)
	ENDIF(SWORD_PYTHON_2)

	IF(SWORD_PYTHON_3)
		SET(SWORD_PYTHON_VERSION 3)
		ADD_SUBDIRECTORY(python python3)
	ENDIF(SWORD_PYTHON_3)

	IF(SWORD_PERL)
		ADD_SUBDIRECTORY(perl)
	ENDIF(SWORD_PERL)
ENDIF(NOT SWIG_FOUND)

=== examples/classes/Makefile ===
TARGETS= ciphercng swmgrex verseranges versevalid lastVerseInChapter verseposition simplechapter flatapilookup flatapiparsekey flatapisearch versenorm flatapiinstallmgr verseconvert
all: $(TARGETS)

clean:
	rm $(TARGETS)

.cpp:
	g++ -O0 -g -Wall -Werror `pkg-config --cflags sword` $< -o $@ `pkg-config --libs sword`
.c:
	gcc -O0 -g -Wall -Werror `pkg-config --cflags sword` $< -o $@ `pkg-config --libs sword` -lstdc++

=== examples/tasks/CMakeLists.txt ===
##################################################################################
# These are some examples.  If you want examples to be built, you need to define
# SWORD_BUILD_EXAMPLES="Yes".  These will not be installed, so don't worry about
# that.
# 
MESSAGE(STATUS "\n-- CONFIGURING LIBRARY EXAMPLES")
SET(example_PROGRAMS
	parallelbibles
	simpleverselookup
	listbiblebooknames
)

FOREACH(DEMO ${example_PROGRAMS})
	ADD_EXECUTABLE("${DEMO}"	"${DEMO}.cpp")
	TARGET_LINK_LIBRARIES("${DEMO}" sword)
ENDFOREACH(DEMO ${example_PROGRAMS})

=== utilities/diatheke/CMakeLists.txt ===
####################################################################
# And, of course, diatheke is a beast unto itself
#
# Let's go!
#
ADD_EXECUTABLE(diatheke
	diatheke.cpp
	corediatheke.cpp
	diathekemgr.cpp
	diafiltmgr.cpp
	thmlcgi.cpp
	gbfcgi.cpp
	osiscgi.cpp
)
IF(BUILDING_SHARED)
	TARGET_LINK_LIBRARIES(diatheke sword)
ELSE(BUILDING_SHARED)
	TARGET_LINK_LIBRARIES(diatheke sword_static)
ENDIF(BUILDING_SHARED)
INSTALL(TARGETS diatheke
	DESTINATION "${BINDIR}"
	COMPONENT utilities
)

=== bindings/objc/dependencies/Makefile ===
LIBCURLVERSION=7.57.0
ICUVERSION=53.1
CLUCENEVERSION=9.21b

all: curl/unpacked icu/unpacked clucene/unpacked

clean: curlclean icuclean cluceneclean

libcurl_src.tar.gz:
	wget http://crosswire.org/ftpmirror/pub/sword/dependencies/apple/libcurl-${LIBCURLVERSION}/libcurl_src.tar.gz

clucene_src.tar.gz:
	wget http://crosswire.org/ftpmirror/pub/sword/dependencies/apple/clucene-${CLUCENEVERSION}/clucene_src.tar.gz

icu_src.tar.gz:
	wget http://crosswire.org/ftpmirror/pub/sword/dependencies/apple/icu-${ICUVERSION}/icu_src.tar.gz


curl/unpacked: libcurl_src.tar.gz
	tar xjfv libcurl_src.tar.gz
	touch curl/unpacked

icu/unpacked: icu_src.tar.gz
	tar xzfv icu_src.tar.gz
	touch icu/unpacked

clucene/unpacked: clucene_src.tar.gz
	tar xzfv clucene_src.tar.gz
	touch clucene/unpacked

curlclean:
	rm -rf libcurl* curl

icuclean:
	rm -rf icu*

cluceneclean:
	rm -rf clucene*

=== bindings/swig/perl/CMakeLists.txt ===
# This method works but there is no good way to install the results of it
#FIND_PACKAGE(PerlLibs REQUIRED)
#INCLUDE_DIRECTORIES(${PERL_INCLUDE_PATH})
#
#SET_SOURCE_FILES_PROPERTIES(../sword.i PROPERTIES CPLUSPLUS ON)
#SET_SOURCE_FILES_PROPERTIES(../sword.i PROPERTIES SWIG_FLAGS "")
#
#SWIG_ADD_MODULE(Sword perl
#	"../sword.i"
#)
#
#SWIG_LINK_LIBRARIES(Sword ${PERL_LIBRARY} ${SWORD_LINK_NAME})

FIND_PACKAGE(Perl REQUIRED)

SET(PERL_MAKEFILE "#!${PERL_EXECUTABLE}

use ExtUtils::MakeMaker;

# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written
WriteMakefile(
	'NAME'		=> 'Sword',
	'VERSION'	=> '${SWORD_VERSION}',
	'INC'		=> '-I\"${CMAKE_SOURCE_DIR}/include\" -I\"${CMAKE_CURRENT_SOURCE_DIR}/..\"',
	'DEFINE'	=> '-DSWIG',
	'LIBS'		=> '-L\"${CMAKE_BINARY_DIR}\" -lsword -lz',
	'FIRST_MAKEFILE' => 'Makefile.perlswig',
	'PREREQ_PM'	=> {},
		($] >= 5.005 ? ## Add these new keywords supported since 5.005
		(ABSTRACT => 'Sword Project perl bindings', # retrieve abstract from module
		AUTHOR => 'Sword Project <sword-devel@crosswire.org>') : ()),
);

rename 'Makefile.perlswig', 'Makefile.perlswig.old' or die \"Can't rename Makefile\";
open(INPUT, '<Makefile.perlswig.old') or die \"Can't open input Makefile.old\";
open(OUTPUT,'>Makefile.perlswig') or die \"Can't open output Makefile\";
while (<INPUT>) {
  s/\\-lsword/\\-lsword \\-lstdc\\+\\+/;
  print OUTPUT \"$_\";
}

close INPUT;
close OUTPUT;")
FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/Makefile.PL "${PERL_MAKEFILE}")

SET(SKIP_MAKEFILE "\\.old
~$
\\.bak
^CVS
Makefile$")
FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/Makefile.SKIP "${SKIP_MAKEFILE}")

SWORD_SWIG_GENERATE(perl)

ADD_CUSTOM_COMMAND(OUTPUT MANIFEST Makefile.perlswig
	COMMAND ${PERL_EXECUTABLE} Makefile.PL && make -f Makefile.perlswig clean
	COMMAND ${PERL_EXECUTABLE} Makefile.PL && make -f Makefile.perlswig manifest
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

ADD_CUSTOM_TARGET(perlswig ALL
	COMMAND make -f Makefile.perlswig
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Sword.cxx ${CMAKE_CURRENT_BINARY_DIR}/Makefile.perlswig ${SWORD_LINK_NAME}
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

INSTALL(SCRIPT install.cmake)

MESSAGE(STATUS "Perl: yes")

=== debian/changelog ===
sword (1.9.0+dfsg-8) unstable; urgency=medium

  * Team upload
  * Remove unnecessary python3:Provides
  * Override minimum CMake version (Closes: #1113555)
  * Enable autopkgtest

 -- Bastian Germann <bage@debian.org>  Mon, 01 Sep 2025 11:43:52 +0200

sword (1.9.0+dfsg-7) unstable; urgency=medium

  * Team upload
  * Add Build-Depends: python3-setuptools (Closes: #1080805)

 -- Bastian Germann <bage@debian.org>  Sun, 08 Sep 2024 17:40:54 +0000

sword (1.9.0+dfsg-6) unstable; urgency=medium

  * Add ftpparse public domain statement

 -- Bastian Germann <bage@debian.org>  Sun, 03 Mar 2024 14:47:44 +0000

sword (1.9.0+dfsg-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062936

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 17:52:34 +0000

sword (1.9.0+dfsg-5) unstable; urgency=medium

  * Team upload
  * Remove unnecessary perl
  * Remove old repack script
  * Remove obvious quilt info
  * Remove bzr-builddeb cruft
  * Install python with deb layout (Closes: #1054784)

 -- Bastian Germann <bage@debian.org>  Fri, 27 Oct 2023 22:32:31 +0000

sword (1.9.0+dfsg-4) unstable; urgency=medium

  [ Teus Benschop ]
  * Add debian/gbp.conf
  * d/gbp.conf update

  [ Bastian Germann ]
  * Set absolute libdir to find CLucene/clucene-config.h

 -- Teus Benschop <teusbenschop@debian.org>  Sat, 19 Dec 2020 14:12:23 +0100

sword (1.9.0+dfsg-3) unstable; urgency=medium

  * update standards-version
  * new API upload to unstable after release team ack

 -- Teus Benschop <teusbenschop@debian.org>  Fri, 27 Nov 2020 21:02:38 +0100

sword (1.9.0+dfsg-2) experimental; urgency=medium

  [ Bastian Germann ]
  * Team upload.
  * Fix DEB_HOST_* variable use in two contexts
  * Fix lintian: multi-arch-same-package-calls-pycompile

 -- Teus Benschop <teusbenschop@debian.org>  Thu, 12 Nov 2020 20:58:40 +0100

sword (1.9.0+dfsg-1) experimental; urgency=medium

  [ Bastian Germann ]
  * Team upload.
  * Drop Dimitri from uploaders
  * Add missing trailing newline
  * Reset repacksuffix to +dfsg
  * Refresh patches for 1.9.0
  * Exclude Android bindings
  * include/untgz.h was removed from upstream
  * Use upstream man pages
  * Rename the library pkg
  * Update to debhelper-compat 13
  * Amend d/copyright file
  * Enable all compressions
  * New upstream version 1.9.0+dfsg
  * Switch to cmake
  * Add package python3-sword (Closes: #950976)
  * d/copyright: Add more untgz-related info

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * Use secure URI in Homepage field.
  * Drop unnecessary dependency on dh-autoreconf.
  * Rely on pre-initialized dpkg-architecture variables.
  * Fix day-of-week for changelog entry 1.5.5-1.

  [ Daniel Glassey ]
  * Replace man pages with ones from sword project repo
  * d/copyright use Files-Excluded feature instead of the
      dfsg.sh script for generating +dfsg tarballs

 -- Teus Benschop <teusbenschop@debian.org>  Wed, 11 Nov 2020 11:11:36 +0100

sword (1.8.1+dfsg-8.2) unstable; urgency=high

  * Non-maintainer upload.
  * Add workaround for building on mips64el. (Closes: #962230)

 -- Adrian Bunk <bunk@debian.org>  Thu, 18 Jun 2020 19:00:26 +0300

sword (1.8.1+dfsg-8.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fixed ICU checking. Thanks to László Böszörményi <gcs@debian.org>.
    (Closes: #962265)

 -- Gleisson Jesuino Joaquim Cardoso <gleissoncg2@gmail.com>  Mon, 08 Jun 2020 21:39:54 -0300

=== debian/control ===
--- 
+++ 
@@ -21,7 +21,7 @@
  Dominique Corbex <dominique@corbex.org>,
  Teus Benschop <teusjannette@gmail.com>
 Standards-Version: 4.5.1
-Rules-Requires-Root: no
+Testsuite: autopkgtest-pkg-pybuild
 Homepage: https://www.crosswire.org/sword/
 Vcs-Browser: https://salsa.debian.org/pkg-crosswire-team/sword
 Vcs-Git: https://salsa.debian.org/pkg-crosswire-team/sword.git
@@ -97,7 +97,6 @@
 Architecture: any
 Section: python
 Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
-Provides: ${python3:Provides}
 Description: Python 3 bindings for the SWORD bible library
  The SWORD Project is an open source, cross-platform (Linux, Windows, Solaris,
  MacOSX etc.) API/library for Bible software with a constantly growing list

=== debian/rules ===
#!/usr/bin/make -f
DH_VERBOSE := 1
include /usr/share/dpkg/architecture.mk

WFLAGS   := -Wall
# Hardening
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --with python3 -Scmake

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_INSTALL_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)" -DSYSCONF_INSTALL_DIR=/etc -DCMAKE_POLICY_VERSION_MINIMUM=3.5 -DSWORD_PYTHON_3:BOOL=TRUE

override_dh_install:
	-chrpath -d debian/tmp/usr/bin/*
	-chrpath -d debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*so*
	dh_install
	# Don't embed absolute build path in wrapper scripts
	sed -i '/# Add our own library path TO LD_LIBRARY_PATH/d' debian/*/usr/bin/*
	sed -i '/LD_LIBRARY_PATH="\//d' debian/*/usr/bin/*
	# Remove empty directory: usr/share/sword/modules
	-rmdir debian/libsword-common/usr/share/sword/modules

=== debian/watch ===
# debian/watch
# Debian uscan file for `sword` package.
# Manpage: `uscan(1)`

# Compulsory line, this is a version 4 file
version=4

# Releases at crosswire.org
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//,repacksuffix=+dfsg \
  https://www.crosswire.org/ftpmirror/pub/sword/source/v([\d\.]+)/sword-(.*)\.tar\.gz debian true
